// Copyright 2009 The Go Authors. All rights reserved.
// Use of this source code is governed by a BSD-style
// license that can be found in the LICENSE file.

package sw64

import (
	"cmd/compile/internal/objw"
	"cmd/compile/internal/types"
	"cmd/internal/obj"
	"cmd/internal/obj/sw64"
)

func zerorange(pp *objw.Progs, p *obj.Prog, off, cnt int64, _ *uint32) *obj.Prog {
	base := p.Ctxt.FixedFrameSize() + off
	for i := int64(0); i < cnt; i += int64(types.PtrSize) {
		// STL ZERO, FixedFrameSize+off+i(SP)
		p = pp.Append(p, sw64.ASTL, obj.TYPE_REG, sw64.REGZERO, 0, obj.TYPE_MEM, sw64.REGSP, base+i)
	}

	return p
}

//zxw new change
func ginsnop(pp *objw.Progs) *obj.Prog {
	p := pp.Prog(sw64.ALDI)
	p.From.Type = obj.TYPE_REG
	p.From.Reg = sw64.REG_R31

	p.To.Type = obj.TYPE_CONST
	p.To.Offset = 0
	return p
}
