//go:build sw64
// +build sw64

#include "textflag.h"

// func xorBytesSW64(dst, a, b *byte n int)
TEXT ·xorBytesSW64(SB), NOSPLIT, $0
	LDL R0, dst+0(FP)
	LDL R1, a+8(FP)
	LDL R2, b+16(FP)
	LDL R3, n+24(FP)
	CMPLT R3, $8, R4
	BNE R4, less_than8
loop_8:
	LDL R11, (R1) 
	LDL R12, (R2)
	LDI R1, 8(R1)  // addr(a) + 8
	LDI R2, 8(R2)  // addr(b) + 8
	XOR R11, R12, R12
	STL R12, (R0)
	LDI R0, 8(R0)  // addr(dst) +8
	LDI R3, -8(R3)  // n - 8
	CMPLT R3, $8, R4
	BEQ R4, loop_8
less_than8:
	BEQ R3, end
	CMPLT R3, $4, R4
	BNE R4, less_than4
	LDW R13, (R1)
	LDW R14, (R2)
	LDI R1, 4(R1)
	LDI R2, 4(R2)
	XOR R13, R14, R14
	STW R14, (R0)
	LDI R0, 4(R0)
	LDI R3, -4(R3)  // n - 4
less_than4:
	CMPLT R3, $2, R4
	BNE R4, less_than2
	LDHU R16, (R1)
	LDHU R17, (R2)
	LDI R1, 2(R1)
	LDI R2, 2(R2)
	XOR R16, R17, R17
	STH R17, (R0)
	LDI R0, 2(R0)
	LDI R3, -2(R3)  // n - 2
less_than2:
	BEQ R3, end
	LDBU R18, (R1)
	LDBU R19, (R2)
	XOR R18, R19, R19
	STB R19, (R0)
end:
	RET
	
