// Copyright 2017 The Go Authors. All rights reserved.
// Use of this source code is governed by a BSD-style
// license that can be found in the LICENSE file.

#include "textflag.h"

// castagnoliUpdate updates the non-inverted crc with the given data.

// func castagnoliUpdate(crc uint32, p []byte) uint32
TEXT ·castagnoliUpdate(SB),NOSPLIT,$0-36
	LDW	R9, crc+0(FP)  // CRC value
	LDL	 R13, p+8(FP)  // data pointer
	LDL R11,	p_len+16(FP)  // len(p)
	ZAPNOT R9, $15, R9

	CMPLT	R11, $8, R8
	BNE	R8, less_than_8

update:
	LDLA R10,	8(R13)
	CRC32CL	R9, R10, R9
	SUBL	R11, $8, R11

	CMPLT	R11, $8, R8
	BNE	R8, less_than_8

	JMP	update

less_than_8:
	AND R11, $4, R8
	BEQ R8, less_than_4

	LDWA	R10, 4(R13)
	ZAPNOT R10, $15, R10
	CRC32CW	R9, R10, R9
	SUBL	R11, $4, R11

less_than_4:
	AND R11, $2, R8
	BEQ	R8, less_than_2

	LDHUA	R10, 2(R13)
	CRC32CH	R9, R10, R9
	SUBL	R11, $2, R11

less_than_2:
	BEQ	R11, done

	LDBU	R10, (R13)
	CRC32CB	R9, R10, R9

done:
	STW	R9, ret+32(FP)
	RET

// ieeeUpdate updates the non-inverted crc with the given data.

// func ieeeUpdate(crc uint32, p []byte) uint32
TEXT ·ieeeUpdate(SB),NOSPLIT,$0-36
	LDW	R9, crc+0(FP)  // CRC value
	LDL	 R13, p+8(FP)  // data pointer
	LDL R11,	p_len+16(FP)  // len(p)
	ZAPNOT R9, $15, R9

	CMPLT	R11, $8, R8
	BNE	R8, less_than_8

update:
	LDLA R10,	8(R13)
	CRC32L	R9, R10, R9
	SUBL	R11, $8, R11

	CMPLT	R11, $8, R8
	BNE	R8, less_than_8

	JMP	update

less_than_8:
	CMPLT R11, $4, R8
	BNE R8, less_than_4

	LDWA	R10, 4(R13)
	ZAPNOT R10, $15, R10
	CRC32W	R9, R10, R9
	SUBL	R11, $4, R11

less_than_4:
	CMPLT R11, $2, R8
	BNE	R8, less_than_2

	LDHUA	R10, 2(R13)
	CRC32H	R9, R10, R9
	SUBL	R11, $2, R11

less_than_2:
	BEQ	R11, done

	LDBU	R10, (R13)
	CRC32B	R9, R10, R9

done:
	STW	R9, ret+32(FP)
	RET
