// Copyright 2015 The Go Authors. All rights reserved.
// Use of this source code is governed by a BSD-style
// license that can be found in the LICENSE file.

//go:build linux && sw64

package runtime

//var randomNumber uint32

func archauxv(tag, val uintptr) {
	/*	switch tag {
		case _AT_RANDOM:
			// sysargs filled in startupRandomData, but that
			// pointer may not be word aligned, so we must treat
			// it as a byte array.
			randomNumber = uint32(startupRandomData[4]) | uint32(startupRandomData[5])<<8 |
				uint32(startupRandomData[6])<<16 | uint32(startupRandomData[7])<<24
		}*/
}
func osArchInit() {}

func cputicks() int64 {
	// Currently cputicks() is used in blocking profiler and to seed fastrand().
	// nanotime() is a poor approximation of CPU ticks that is enough for the profiler.
	// randomNumber provides better seeding of fastrand.
	//return nanotime() + int64(randomNumber)
	return nanotime()
}

const (
	_NSIG        = 64
	_SIG_BLOCK   = 1
	_SIG_UNBLOCK = 2
	_SIG_SETMASK = 3

	_SI_USER    = 0
	_SS_DISABLE = 2
)

type sigset [1]uint64

var sigset_all = sigset{^uint64(0)}

//go:nosplit
//go:nowritebarrierrec
func sigaddset(mask *sigset, i int) {
	(*mask)[(i-1)/64] |= 1 << ((uint32(i) - 1) & 63)
}

func sigdelset(mask *sigset, i int) {
	(*mask)[(i-1)/64] &^= 1 << ((uint32(i) - 1) & 63)
}

func sigfillset(mask *[1]uint64) {
	(*mask)[0] = ^uint64(0)
}
